import usb
import math
from time import sleep

RQ_SET_FAN    = 0
VENDOR_RQ_GET_TEMP = 1

def find_board():
	board = None
	for bus in usb.busses():
		for dev in bus.devices:
			if dev.idVendor == 0x16c0 and dev.idProduct == 0x05dc: #Define USB Device Number
				return dev
	return None

class Board:
    def __init__(self):
        #print "Looking for MCU board..."
        dev = find_board()
        if not dev: raise "MCU board not found!"
        #print "MCU board found"
        self.handle = dev.open()

    def set_fan(self,pin,val):
	reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_OUT
	self.handle.controlMsg(reqType, RQ_SET_FAN, None, value=val*256+pin)

#board = find_board()
#handle = board.open()
#temp = 0.0

b = Board()

while(1):
	#dum = raw_input("Press any key to continue...")
	sleep(0.5)
	req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
	temp = b.handle.controlMsg(req, 1, 2)
	Rl = (50000-(temp[0]*256.0+temp[1])/1023.0*50000)/((temp[0]*256.0+temp[1])/1023.0*5)
	y=math.log(Rl/1000.0,10)
	x=(y-1)/(-0.02)+ 25
	
	if x<=24 :
		b.set_fan(2,0)
		b.set_fan(4,0)
	elif x<=26 :
		b.set_fan(2,0)
		b.set_fan(4,1)
	elif x<=28 :
		b.set_fan(2,1)
		b.set_fan(4,0)
	else:
		b.set_fan(2,1)
		b.set_fan(4,1)
	print "%.2f"%x
